<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: Parser">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.util.ArrayList;</span>
<span class="source-line-no">021</span><span id="line-21">import java.util.Arrays;</span>
<span class="source-line-no">022</span><span id="line-22">import java.util.Enumeration;</span>
<span class="source-line-no">023</span><span id="line-23">import java.util.List;</span>
<span class="source-line-no">024</span><span id="line-24">import java.util.ListIterator;</span>
<span class="source-line-no">025</span><span id="line-25">import java.util.Properties;</span>
<span class="source-line-no">026</span><span id="line-26"></span>
<span class="source-line-no">027</span><span id="line-27">/**</span>
<span class="source-line-no">028</span><span id="line-28"> * {@code Parser} creates {@link CommandLine}s.</span>
<span class="source-line-no">029</span><span id="line-29"> *</span>
<span class="source-line-no">030</span><span id="line-30"> * @deprecated since 1.3, the two-pass parsing with the flatten method is not enough flexible to handle complex cases</span>
<span class="source-line-no">031</span><span id="line-31"> */</span>
<span class="source-line-no">032</span><span id="line-32">@Deprecated</span>
<span class="source-line-no">033</span><span id="line-33">public abstract class Parser implements CommandLineParser {</span>
<span class="source-line-no">034</span><span id="line-34">    /** CommandLine instance */</span>
<span class="source-line-no">035</span><span id="line-35">    protected CommandLine cmd;</span>
<span class="source-line-no">036</span><span id="line-36"></span>
<span class="source-line-no">037</span><span id="line-37">    /** current Options */</span>
<span class="source-line-no">038</span><span id="line-38">    private Options options;</span>
<span class="source-line-no">039</span><span id="line-39"></span>
<span class="source-line-no">040</span><span id="line-40">    /** list of required options strings */</span>
<span class="source-line-no">041</span><span id="line-41">    private List requiredOptions;</span>
<span class="source-line-no">042</span><span id="line-42"></span>
<span class="source-line-no">043</span><span id="line-43">    /**</span>
<span class="source-line-no">044</span><span id="line-44">     * Throws a {@link MissingOptionException} if all of the required options are not present.</span>
<span class="source-line-no">045</span><span id="line-45">     *</span>
<span class="source-line-no">046</span><span id="line-46">     * @throws MissingOptionException if any of the required Options are not present.</span>
<span class="source-line-no">047</span><span id="line-47">     */</span>
<span class="source-line-no">048</span><span id="line-48">    protected void checkRequiredOptions() throws MissingOptionException {</span>
<span class="source-line-no">049</span><span id="line-49">        // if there are required options that have not been processed</span>
<span class="source-line-no">050</span><span id="line-50">        if (!getRequiredOptions().isEmpty()) {</span>
<span class="source-line-no">051</span><span id="line-51">            throw new MissingOptionException(getRequiredOptions());</span>
<span class="source-line-no">052</span><span id="line-52">        }</span>
<span class="source-line-no">053</span><span id="line-53">    }</span>
<span class="source-line-no">054</span><span id="line-54"></span>
<span class="source-line-no">055</span><span id="line-55">    /**</span>
<span class="source-line-no">056</span><span id="line-56">     * Subclasses must implement this method to reduce the {@code arguments} that have been passed to the parse method.</span>
<span class="source-line-no">057</span><span id="line-57">     *</span>
<span class="source-line-no">058</span><span id="line-58">     * @param opts The Options to parse the arguments by.</span>
<span class="source-line-no">059</span><span id="line-59">     * @param arguments The arguments that have to be flattened.</span>
<span class="source-line-no">060</span><span id="line-60">     * @param stopAtNonOption specifies whether to stop flattening when a non option has been encountered</span>
<span class="source-line-no">061</span><span id="line-61">     * @return a String array of the flattened arguments</span>
<span class="source-line-no">062</span><span id="line-62">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">063</span><span id="line-63">     */</span>
<span class="source-line-no">064</span><span id="line-64">    protected abstract String[] flatten(Options opts, String[] arguments, boolean stopAtNonOption) throws ParseException;</span>
<span class="source-line-no">065</span><span id="line-65"></span>
<span class="source-line-no">066</span><span id="line-66">    /**</span>
<span class="source-line-no">067</span><span id="line-67">     * Gets the options.</span>
<span class="source-line-no">068</span><span id="line-68">     *</span>
<span class="source-line-no">069</span><span id="line-69">     * @return the options.</span>
<span class="source-line-no">070</span><span id="line-70">     */</span>
<span class="source-line-no">071</span><span id="line-71">    protected Options getOptions() {</span>
<span class="source-line-no">072</span><span id="line-72">        return options;</span>
<span class="source-line-no">073</span><span id="line-73">    }</span>
<span class="source-line-no">074</span><span id="line-74"></span>
<span class="source-line-no">075</span><span id="line-75">    /**</span>
<span class="source-line-no">076</span><span id="line-76">     * Gets the required options.</span>
<span class="source-line-no">077</span><span id="line-77">     *</span>
<span class="source-line-no">078</span><span id="line-78">     * @return the required options.</span>
<span class="source-line-no">079</span><span id="line-79">     */</span>
<span class="source-line-no">080</span><span id="line-80">    protected List getRequiredOptions() {</span>
<span class="source-line-no">081</span><span id="line-81">        return requiredOptions;</span>
<span class="source-line-no">082</span><span id="line-82">    }</span>
<span class="source-line-no">083</span><span id="line-83"></span>
<span class="source-line-no">084</span><span id="line-84">    /**</span>
<span class="source-line-no">085</span><span id="line-85">     * Parses the specified {@code arguments} based on the specified {@link Options}.</span>
<span class="source-line-no">086</span><span id="line-86">     *</span>
<span class="source-line-no">087</span><span id="line-87">     * @param options the {@code Options}</span>
<span class="source-line-no">088</span><span id="line-88">     * @param arguments the {@code arguments}</span>
<span class="source-line-no">089</span><span id="line-89">     * @return the {@code CommandLine}</span>
<span class="source-line-no">090</span><span id="line-90">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">091</span><span id="line-91">     */</span>
<span class="source-line-no">092</span><span id="line-92">    @Override</span>
<span class="source-line-no">093</span><span id="line-93">    public CommandLine parse(final Options options, final String[] arguments) throws ParseException {</span>
<span class="source-line-no">094</span><span id="line-94">        return parse(options, arguments, null, false);</span>
<span class="source-line-no">095</span><span id="line-95">    }</span>
<span class="source-line-no">096</span><span id="line-96"></span>
<span class="source-line-no">097</span><span id="line-97">    /**</span>
<span class="source-line-no">098</span><span id="line-98">     * Parses the specified {@code arguments} based on the specified {@link Options}.</span>
<span class="source-line-no">099</span><span id="line-99">     *</span>
<span class="source-line-no">100</span><span id="line-100">     * @param options the {@code Options}</span>
<span class="source-line-no">101</span><span id="line-101">     * @param arguments the {@code arguments}</span>
<span class="source-line-no">102</span><span id="line-102">     * @param stopAtNonOption if {@code true} an unrecognized argument stops the parsing and the remaining arguments</span>
<span class="source-line-no">103</span><span id="line-103">     *        are added to the {@link CommandLine}s args list. If {@code false} an unrecognized argument triggers a</span>
<span class="source-line-no">104</span><span id="line-104">     *        ParseException.</span>
<span class="source-line-no">105</span><span id="line-105">     * @return the {@code CommandLine}</span>
<span class="source-line-no">106</span><span id="line-106">     * @throws ParseException if an error occurs when parsing the arguments.</span>
<span class="source-line-no">107</span><span id="line-107">     */</span>
<span class="source-line-no">108</span><span id="line-108">    @Override</span>
<span class="source-line-no">109</span><span id="line-109">    public CommandLine parse(final Options options, final String[] arguments, final boolean stopAtNonOption) throws ParseException {</span>
<span class="source-line-no">110</span><span id="line-110">        return parse(options, arguments, null, stopAtNonOption);</span>
<span class="source-line-no">111</span><span id="line-111">    }</span>
<span class="source-line-no">112</span><span id="line-112"></span>
<span class="source-line-no">113</span><span id="line-113">    /**</span>
<span class="source-line-no">114</span><span id="line-114">     * Parse the arguments according to the specified options and properties.</span>
<span class="source-line-no">115</span><span id="line-115">     *</span>
<span class="source-line-no">116</span><span id="line-116">     * @param options the specified Options</span>
<span class="source-line-no">117</span><span id="line-117">     * @param arguments the command line arguments</span>
<span class="source-line-no">118</span><span id="line-118">     * @param properties command line option name-value pairs</span>
<span class="source-line-no">119</span><span id="line-119">     * @return the list of atomic option and value tokens</span>
<span class="source-line-no">120</span><span id="line-120">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">121</span><span id="line-121">     *</span>
<span class="source-line-no">122</span><span id="line-122">     * @since 1.1</span>
<span class="source-line-no">123</span><span id="line-123">     */</span>
<span class="source-line-no">124</span><span id="line-124">    public CommandLine parse(final Options options, final String[] arguments, final Properties properties) throws ParseException {</span>
<span class="source-line-no">125</span><span id="line-125">        return parse(options, arguments, properties, false);</span>
<span class="source-line-no">126</span><span id="line-126">    }</span>
<span class="source-line-no">127</span><span id="line-127"></span>
<span class="source-line-no">128</span><span id="line-128">    /**</span>
<span class="source-line-no">129</span><span id="line-129">     * Parse the arguments according to the specified options and properties.</span>
<span class="source-line-no">130</span><span id="line-130">     *</span>
<span class="source-line-no">131</span><span id="line-131">     * @param options the specified Options</span>
<span class="source-line-no">132</span><span id="line-132">     * @param arguments the command line arguments</span>
<span class="source-line-no">133</span><span id="line-133">     * @param properties command line option name-value pairs</span>
<span class="source-line-no">134</span><span id="line-134">     * @param stopAtNonOption if {@code true} an unrecognized argument stops the parsing and the remaining arguments</span>
<span class="source-line-no">135</span><span id="line-135">     *        are added to the {@link CommandLine}s args list. If {@code false} an unrecognized argument triggers a</span>
<span class="source-line-no">136</span><span id="line-136">     *        ParseException.</span>
<span class="source-line-no">137</span><span id="line-137">     *</span>
<span class="source-line-no">138</span><span id="line-138">     * @return the list of atomic option and value tokens</span>
<span class="source-line-no">139</span><span id="line-139">     *</span>
<span class="source-line-no">140</span><span id="line-140">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">141</span><span id="line-141">     *</span>
<span class="source-line-no">142</span><span id="line-142">     * @since 1.1</span>
<span class="source-line-no">143</span><span id="line-143">     */</span>
<span class="source-line-no">144</span><span id="line-144">    public CommandLine parse(final Options options, String[] arguments, final Properties properties, final boolean stopAtNonOption) throws ParseException {</span>
<span class="source-line-no">145</span><span id="line-145">        // clear out the data in options in case it's been used before (CLI-71)</span>
<span class="source-line-no">146</span><span id="line-146">        for (final Option opt : options.helpOptions()) {</span>
<span class="source-line-no">147</span><span id="line-147">            opt.clearValues();</span>
<span class="source-line-no">148</span><span id="line-148">        }</span>
<span class="source-line-no">149</span><span id="line-149"></span>
<span class="source-line-no">150</span><span id="line-150">        // clear the data from the groups</span>
<span class="source-line-no">151</span><span id="line-151">        for (final OptionGroup group : options.getOptionGroups()) {</span>
<span class="source-line-no">152</span><span id="line-152">            group.setSelected(null);</span>
<span class="source-line-no">153</span><span id="line-153">        }</span>
<span class="source-line-no">154</span><span id="line-154"></span>
<span class="source-line-no">155</span><span id="line-155">        // initialize members</span>
<span class="source-line-no">156</span><span id="line-156">        setOptions(options);</span>
<span class="source-line-no">157</span><span id="line-157"></span>
<span class="source-line-no">158</span><span id="line-158">        cmd = new CommandLine();</span>
<span class="source-line-no">159</span><span id="line-159"></span>
<span class="source-line-no">160</span><span id="line-160">        boolean eatTheRest = false;</span>
<span class="source-line-no">161</span><span id="line-161"></span>
<span class="source-line-no">162</span><span id="line-162">        if (arguments == null) {</span>
<span class="source-line-no">163</span><span id="line-163">            arguments = new String[0];</span>
<span class="source-line-no">164</span><span id="line-164">        }</span>
<span class="source-line-no">165</span><span id="line-165"></span>
<span class="source-line-no">166</span><span id="line-166">        final List&lt;String&gt; tokenList = Arrays.asList(flatten(getOptions(), arguments, stopAtNonOption));</span>
<span class="source-line-no">167</span><span id="line-167"></span>
<span class="source-line-no">168</span><span id="line-168">        final ListIterator&lt;String&gt; iterator = tokenList.listIterator();</span>
<span class="source-line-no">169</span><span id="line-169"></span>
<span class="source-line-no">170</span><span id="line-170">        // process each flattened token</span>
<span class="source-line-no">171</span><span id="line-171">        while (iterator.hasNext()) {</span>
<span class="source-line-no">172</span><span id="line-172">            final String t = iterator.next();</span>
<span class="source-line-no">173</span><span id="line-173"></span>
<span class="source-line-no">174</span><span id="line-174">            // the value is the double-dash</span>
<span class="source-line-no">175</span><span id="line-175">            if ("--".equals(t)) {</span>
<span class="source-line-no">176</span><span id="line-176">                eatTheRest = true;</span>
<span class="source-line-no">177</span><span id="line-177">            }</span>
<span class="source-line-no">178</span><span id="line-178"></span>
<span class="source-line-no">179</span><span id="line-179">            // the value is a single dash</span>
<span class="source-line-no">180</span><span id="line-180">            else if ("-".equals(t)) {</span>
<span class="source-line-no">181</span><span id="line-181">                if (stopAtNonOption) {</span>
<span class="source-line-no">182</span><span id="line-182">                    eatTheRest = true;</span>
<span class="source-line-no">183</span><span id="line-183">                } else {</span>
<span class="source-line-no">184</span><span id="line-184">                    cmd.addArg(t);</span>
<span class="source-line-no">185</span><span id="line-185">                }</span>
<span class="source-line-no">186</span><span id="line-186">            }</span>
<span class="source-line-no">187</span><span id="line-187"></span>
<span class="source-line-no">188</span><span id="line-188">            // the value is an option</span>
<span class="source-line-no">189</span><span id="line-189">            else if (t.startsWith("-")) {</span>
<span class="source-line-no">190</span><span id="line-190">                if (stopAtNonOption &amp;&amp; !getOptions().hasOption(t)) {</span>
<span class="source-line-no">191</span><span id="line-191">                    eatTheRest = true;</span>
<span class="source-line-no">192</span><span id="line-192">                    cmd.addArg(t);</span>
<span class="source-line-no">193</span><span id="line-193">                } else {</span>
<span class="source-line-no">194</span><span id="line-194">                    processOption(t, iterator);</span>
<span class="source-line-no">195</span><span id="line-195">                }</span>
<span class="source-line-no">196</span><span id="line-196">            }</span>
<span class="source-line-no">197</span><span id="line-197"></span>
<span class="source-line-no">198</span><span id="line-198">            // the value is an argument</span>
<span class="source-line-no">199</span><span id="line-199">            else {</span>
<span class="source-line-no">200</span><span id="line-200">                cmd.addArg(t);</span>
<span class="source-line-no">201</span><span id="line-201"></span>
<span class="source-line-no">202</span><span id="line-202">                if (stopAtNonOption) {</span>
<span class="source-line-no">203</span><span id="line-203">                    eatTheRest = true;</span>
<span class="source-line-no">204</span><span id="line-204">                }</span>
<span class="source-line-no">205</span><span id="line-205">            }</span>
<span class="source-line-no">206</span><span id="line-206"></span>
<span class="source-line-no">207</span><span id="line-207">            // eat the remaining tokens</span>
<span class="source-line-no">208</span><span id="line-208">            if (eatTheRest) {</span>
<span class="source-line-no">209</span><span id="line-209">                while (iterator.hasNext()) {</span>
<span class="source-line-no">210</span><span id="line-210">                    final String str = iterator.next();</span>
<span class="source-line-no">211</span><span id="line-211"></span>
<span class="source-line-no">212</span><span id="line-212">                    // ensure only one double-dash is added</span>
<span class="source-line-no">213</span><span id="line-213">                    if (!"--".equals(str)) {</span>
<span class="source-line-no">214</span><span id="line-214">                        cmd.addArg(str);</span>
<span class="source-line-no">215</span><span id="line-215">                    }</span>
<span class="source-line-no">216</span><span id="line-216">                }</span>
<span class="source-line-no">217</span><span id="line-217">            }</span>
<span class="source-line-no">218</span><span id="line-218">        }</span>
<span class="source-line-no">219</span><span id="line-219"></span>
<span class="source-line-no">220</span><span id="line-220">        processProperties(properties);</span>
<span class="source-line-no">221</span><span id="line-221">        checkRequiredOptions();</span>
<span class="source-line-no">222</span><span id="line-222"></span>
<span class="source-line-no">223</span><span id="line-223">        return cmd;</span>
<span class="source-line-no">224</span><span id="line-224">    }</span>
<span class="source-line-no">225</span><span id="line-225"></span>
<span class="source-line-no">226</span><span id="line-226">    /**</span>
<span class="source-line-no">227</span><span id="line-227">     * Process the argument values for the specified Option {@code opt} using the values retrieved from the specified</span>
<span class="source-line-no">228</span><span id="line-228">     * iterator {@code iter}.</span>
<span class="source-line-no">229</span><span id="line-229">     *</span>
<span class="source-line-no">230</span><span id="line-230">     * @param opt The current Option</span>
<span class="source-line-no">231</span><span id="line-231">     * @param iter The iterator over the flattened command line Options.</span>
<span class="source-line-no">232</span><span id="line-232">     *</span>
<span class="source-line-no">233</span><span id="line-233">     * @throws ParseException if an argument value is required and it is has not been found.</span>
<span class="source-line-no">234</span><span id="line-234">     */</span>
<span class="source-line-no">235</span><span id="line-235">    public void processArgs(final Option opt, final ListIterator&lt;String&gt; iter) throws ParseException {</span>
<span class="source-line-no">236</span><span id="line-236">        // loop until an option is found</span>
<span class="source-line-no">237</span><span id="line-237">        while (iter.hasNext()) {</span>
<span class="source-line-no">238</span><span id="line-238">            final String str = iter.next();</span>
<span class="source-line-no">239</span><span id="line-239"></span>
<span class="source-line-no">240</span><span id="line-240">            // found an Option, not an argument</span>
<span class="source-line-no">241</span><span id="line-241">            if (getOptions().hasOption(str) &amp;&amp; str.startsWith("-")) {</span>
<span class="source-line-no">242</span><span id="line-242">                iter.previous();</span>
<span class="source-line-no">243</span><span id="line-243">                break;</span>
<span class="source-line-no">244</span><span id="line-244">            }</span>
<span class="source-line-no">245</span><span id="line-245"></span>
<span class="source-line-no">246</span><span id="line-246">            // found a value</span>
<span class="source-line-no">247</span><span id="line-247">            try {</span>
<span class="source-line-no">248</span><span id="line-248">                opt.addValueForProcessing(Util.stripLeadingAndTrailingQuotes(str));</span>
<span class="source-line-no">249</span><span id="line-249">            } catch (final RuntimeException exp) {</span>
<span class="source-line-no">250</span><span id="line-250">                iter.previous();</span>
<span class="source-line-no">251</span><span id="line-251">                break;</span>
<span class="source-line-no">252</span><span id="line-252">            }</span>
<span class="source-line-no">253</span><span id="line-253">        }</span>
<span class="source-line-no">254</span><span id="line-254"></span>
<span class="source-line-no">255</span><span id="line-255">        if (opt.getValues() == null &amp;&amp; !opt.hasOptionalArg()) {</span>
<span class="source-line-no">256</span><span id="line-256">            throw new MissingArgumentException(opt);</span>
<span class="source-line-no">257</span><span id="line-257">        }</span>
<span class="source-line-no">258</span><span id="line-258">    }</span>
<span class="source-line-no">259</span><span id="line-259"></span>
<span class="source-line-no">260</span><span id="line-260">    /**</span>
<span class="source-line-no">261</span><span id="line-261">     * Process the Option specified by {@code arg} using the values retrieved from the specified iterator</span>
<span class="source-line-no">262</span><span id="line-262">     * {@code iter}.</span>
<span class="source-line-no">263</span><span id="line-263">     *</span>
<span class="source-line-no">264</span><span id="line-264">     * @param arg The String value representing an Option</span>
<span class="source-line-no">265</span><span id="line-265">     * @param iter The iterator over the flattened command line arguments.</span>
<span class="source-line-no">266</span><span id="line-266">     *</span>
<span class="source-line-no">267</span><span id="line-267">     * @throws ParseException if {@code arg} does not represent an Option</span>
<span class="source-line-no">268</span><span id="line-268">     */</span>
<span class="source-line-no">269</span><span id="line-269">    protected void processOption(final String arg, final ListIterator&lt;String&gt; iter) throws ParseException {</span>
<span class="source-line-no">270</span><span id="line-270">        final boolean hasOption = getOptions().hasOption(arg);</span>
<span class="source-line-no">271</span><span id="line-271"></span>
<span class="source-line-no">272</span><span id="line-272">        // if there is no option throw an UnrecognizedOptionException</span>
<span class="source-line-no">273</span><span id="line-273">        if (!hasOption) {</span>
<span class="source-line-no">274</span><span id="line-274">            throw new UnrecognizedOptionException("Unrecognized option: " + arg, arg);</span>
<span class="source-line-no">275</span><span id="line-275">        }</span>
<span class="source-line-no">276</span><span id="line-276"></span>
<span class="source-line-no">277</span><span id="line-277">        // get the option represented by arg</span>
<span class="source-line-no">278</span><span id="line-278">        final Option opt = (Option) getOptions().getOption(arg).clone();</span>
<span class="source-line-no">279</span><span id="line-279"></span>
<span class="source-line-no">280</span><span id="line-280">        // update the required options and groups</span>
<span class="source-line-no">281</span><span id="line-281">        updateRequiredOptions(opt);</span>
<span class="source-line-no">282</span><span id="line-282"></span>
<span class="source-line-no">283</span><span id="line-283">        // if the option takes an argument value</span>
<span class="source-line-no">284</span><span id="line-284">        if (opt.hasArg()) {</span>
<span class="source-line-no">285</span><span id="line-285">            processArgs(opt, iter);</span>
<span class="source-line-no">286</span><span id="line-286">        }</span>
<span class="source-line-no">287</span><span id="line-287"></span>
<span class="source-line-no">288</span><span id="line-288">        // set the option on the command line</span>
<span class="source-line-no">289</span><span id="line-289">        cmd.addOption(opt);</span>
<span class="source-line-no">290</span><span id="line-290">    }</span>
<span class="source-line-no">291</span><span id="line-291"></span>
<span class="source-line-no">292</span><span id="line-292">    /**</span>
<span class="source-line-no">293</span><span id="line-293">     * Sets the values of Options using the values in {@code properties}.</span>
<span class="source-line-no">294</span><span id="line-294">     *</span>
<span class="source-line-no">295</span><span id="line-295">     * @param properties The value properties to be processed.</span>
<span class="source-line-no">296</span><span id="line-296">     * @throws ParseException if there are any problems encountered while processing the properties.</span>
<span class="source-line-no">297</span><span id="line-297">     */</span>
<span class="source-line-no">298</span><span id="line-298">    protected void processProperties(final Properties properties) throws ParseException {</span>
<span class="source-line-no">299</span><span id="line-299">        if (properties == null) {</span>
<span class="source-line-no">300</span><span id="line-300">            return;</span>
<span class="source-line-no">301</span><span id="line-301">        }</span>
<span class="source-line-no">302</span><span id="line-302"></span>
<span class="source-line-no">303</span><span id="line-303">        for (final Enumeration&lt;?&gt; e = properties.propertyNames(); e.hasMoreElements();) {</span>
<span class="source-line-no">304</span><span id="line-304">            final String option = e.nextElement().toString();</span>
<span class="source-line-no">305</span><span id="line-305"></span>
<span class="source-line-no">306</span><span id="line-306">            final Option opt = options.getOption(option);</span>
<span class="source-line-no">307</span><span id="line-307">            if (opt == null) {</span>
<span class="source-line-no">308</span><span id="line-308">                throw new UnrecognizedOptionException("Default option wasn't defined", option);</span>
<span class="source-line-no">309</span><span id="line-309">            }</span>
<span class="source-line-no">310</span><span id="line-310"></span>
<span class="source-line-no">311</span><span id="line-311">            // if the option is part of a group, check if another option of the group has been selected</span>
<span class="source-line-no">312</span><span id="line-312">            final OptionGroup group = options.getOptionGroup(opt);</span>
<span class="source-line-no">313</span><span id="line-313">            final boolean selected = group != null &amp;&amp; group.getSelected() != null;</span>
<span class="source-line-no">314</span><span id="line-314"></span>
<span class="source-line-no">315</span><span id="line-315">            if (!cmd.hasOption(option) &amp;&amp; !selected) {</span>
<span class="source-line-no">316</span><span id="line-316">                // get the value from the properties instance</span>
<span class="source-line-no">317</span><span id="line-317">                final String value = properties.getProperty(option);</span>
<span class="source-line-no">318</span><span id="line-318"></span>
<span class="source-line-no">319</span><span id="line-319">                if (opt.hasArg()) {</span>
<span class="source-line-no">320</span><span id="line-320">                    if (opt.getValues() == null || opt.getValues().length == 0) {</span>
<span class="source-line-no">321</span><span id="line-321">                        try {</span>
<span class="source-line-no">322</span><span id="line-322">                            opt.addValueForProcessing(value);</span>
<span class="source-line-no">323</span><span id="line-323">                        } catch (final RuntimeException exp) { // NOPMD</span>
<span class="source-line-no">324</span><span id="line-324">                            // if we cannot add the value don't worry about it</span>
<span class="source-line-no">325</span><span id="line-325">                        }</span>
<span class="source-line-no">326</span><span id="line-326">                    }</span>
<span class="source-line-no">327</span><span id="line-327">                } else if (!("yes".equalsIgnoreCase(value) || "true".equalsIgnoreCase(value) || "1".equalsIgnoreCase(value))) {</span>
<span class="source-line-no">328</span><span id="line-328">                    // if the value is not yes, true or 1 then don't add the</span>
<span class="source-line-no">329</span><span id="line-329">                    // option to the CommandLine</span>
<span class="source-line-no">330</span><span id="line-330">                    continue;</span>
<span class="source-line-no">331</span><span id="line-331">                }</span>
<span class="source-line-no">332</span><span id="line-332"></span>
<span class="source-line-no">333</span><span id="line-333">                cmd.addOption(opt);</span>
<span class="source-line-no">334</span><span id="line-334">                updateRequiredOptions(opt);</span>
<span class="source-line-no">335</span><span id="line-335">            }</span>
<span class="source-line-no">336</span><span id="line-336">        }</span>
<span class="source-line-no">337</span><span id="line-337">    }</span>
<span class="source-line-no">338</span><span id="line-338"></span>
<span class="source-line-no">339</span><span id="line-339">    /**</span>
<span class="source-line-no">340</span><span id="line-340">     * Sets the options.</span>
<span class="source-line-no">341</span><span id="line-341">     *</span>
<span class="source-line-no">342</span><span id="line-342">     * @param options the options.</span>
<span class="source-line-no">343</span><span id="line-343">     */</span>
<span class="source-line-no">344</span><span id="line-344">    protected void setOptions(final Options options) {</span>
<span class="source-line-no">345</span><span id="line-345">        this.options = options;</span>
<span class="source-line-no">346</span><span id="line-346">        this.requiredOptions = new ArrayList&lt;&gt;(options.getRequiredOptions());</span>
<span class="source-line-no">347</span><span id="line-347">    }</span>
<span class="source-line-no">348</span><span id="line-348"></span>
<span class="source-line-no">349</span><span id="line-349">    /**</span>
<span class="source-line-no">350</span><span id="line-350">     * Removes the option or its group from the list of expected elements.</span>
<span class="source-line-no">351</span><span id="line-351">     *</span>
<span class="source-line-no">352</span><span id="line-352">     * @param opt</span>
<span class="source-line-no">353</span><span id="line-353">     */</span>
<span class="source-line-no">354</span><span id="line-354">    private void updateRequiredOptions(final Option opt) throws ParseException {</span>
<span class="source-line-no">355</span><span id="line-355">        // if the option is a required option remove the option from</span>
<span class="source-line-no">356</span><span id="line-356">        // the requiredOptions list</span>
<span class="source-line-no">357</span><span id="line-357">        if (opt.isRequired()) {</span>
<span class="source-line-no">358</span><span id="line-358">            getRequiredOptions().remove(opt.getKey());</span>
<span class="source-line-no">359</span><span id="line-359">        }</span>
<span class="source-line-no">360</span><span id="line-360"></span>
<span class="source-line-no">361</span><span id="line-361">        // if the option is in an OptionGroup make that option the selected</span>
<span class="source-line-no">362</span><span id="line-362">        // option of the group</span>
<span class="source-line-no">363</span><span id="line-363">        if (getOptions().getOptionGroup(opt) != null) {</span>
<span class="source-line-no">364</span><span id="line-364">            final OptionGroup group = getOptions().getOptionGroup(opt);</span>
<span class="source-line-no">365</span><span id="line-365"></span>
<span class="source-line-no">366</span><span id="line-366">            if (group.isRequired()) {</span>
<span class="source-line-no">367</span><span id="line-367">                getRequiredOptions().remove(group);</span>
<span class="source-line-no">368</span><span id="line-368">            }</span>
<span class="source-line-no">369</span><span id="line-369"></span>
<span class="source-line-no">370</span><span id="line-370">            group.setSelected(opt);</span>
<span class="source-line-no">371</span><span id="line-371">        }</span>
<span class="source-line-no">372</span><span id="line-372">    }</span>
<span class="source-line-no">373</span><span id="line-373">}</span>




























































</pre>
</div>
</main>
</body>
</html>
